      SUBROUTINE HPSORT(B,N)
C
C     THIS SUBROUTINE SORTS THE DOUBLE PRECISION ARRAY B INTO
C     NONDECREASING ORDER BY THE HPSORT METHOD.  SEE: NIJENHUIS A.
C     AND WILF H.S.(1978) " COMBINATORIAL ALGORITHMS FOR COMPUTERS AND
C     CALCULATORS, SECOND EDITION", CHAP. 15. ACADEMIC PRESS.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION B(N)
C
      IF (N.LE.1) RETURN
      N1=N
      L=1+N/2
 60   L=L-1
      BSTAR=B(L)
      GO TO 10
 70   BSTAR=B(N1)
      B(N1)=B(1)
      N1=N1-1
 10   L1=L
 50   M=2*L1

C     IF (M-N1) 20,30,40

      IF (M-N1.EQ.1) GO TO 20
      IF (M-N1.EQ.2) GO TO 30
      IF (M-N1.EQ.3) GO TO 40

 20   IF (B(M+1).GE.B(M)) M=M+1
 30   IF (BSTAR.GE.B(M)) GO TO 40
      B(L1)=B(M)
      L1=M
      GO TO 50
 40   B(L1)=BSTAR
      IF (L.GT.1) GO TO 60
      IF (N1.GE.2) GO TO 70
      END
